/* Header file for the Freedom Remailer
   1995-1997  jfleming@indiana.edu
   1997-1998  hanne@squirrel.owl.de */

#ifndef FREEDOM_H
#define FREEDOM_H

#define DISCLAIMER \
"Comments: Please report problems with this automated remailing service\n" \
"\tto <%s>. The message sender's identity\n" \
"\tis unknown, unlogged, and not replyable.\n", COMPLAINTS

#define SYSLOG_FACILITY	LOG_USER

#define VERSION		"2.3"

#ifndef REMAILER_DIR
#define REMAILER_DIR	""
#endif /* !REMAILER_DIR */

#define REMAILER_BIN	"remailer"

/* updatestats() argument values */
enum stats_flag {
  STATS_MESSAGE,
  STATS_PGP,
};

/* scan_message() return values */
enum message_type {
  NON_ANON,
  BLOCKED_SENDER,
  NULL_MESSAGE,
  PGP_MESSAGE,
  REMIX_MESSAGE,
  REPGP_MESSAGE,
  ANON_MESSAGE,
  ANON_POST,
  STATS_REQ,
  HELP_REQ,
  KEY_REQ,
  CONF_REQ,
  CUTMARKS,
  ENCRYPT_SUB,
  ENCRYPT_KEY,
  LATENT_TIME,
  URL_REQUEST
};

extern int USE_SYSLOG;
extern int USE_STATS;
extern int USE_MIX;
extern int ALLOW_PGP;
extern int ALLOW_GPG;
extern int ALLOW_POST;
extern int ALLOW_WWW;
extern int ALLOW_LTIME;
extern int SIZE_LIMIT;
extern char remailer_dir[];
extern char cur_dir[];
extern char MIX_DIR[];
extern char QUEUE_DIR[];
extern char PGP_DIR[];
extern char GPG_DIR[];
extern char MAIL_SPOOL[];
extern char MIXMASTER[];
extern char SENDMAIL[];
extern char INEWS[];
extern char PGP[];
extern char GPG[];
extern char WGET[];
extern char HELP_FILE[];
extern char KEY_FILE[];
extern char STATS_FILE[];
extern char PASS_FILE[];
extern char TYPE2_LIST[];
extern char SOURCE_BLOCK[];
extern char DEST_BLOCK[];
extern char GROUP_BLOCK[];
extern char URL_BLOCK[];
extern char HDRFILTER[];
extern char REMAILER_NAME[];
extern char ANON_NAME[];
extern char ORGANIZATION[];
extern char MAIL2NEWS[];
extern char REMAILER_ADDR[];
extern char ANON_ADDR[];
extern char COMPLAINTS[];

/* function prototypes */
int init_remailer(void);
enum message_type scan_message(const char *, char *, const int);
void get_from(const char *, char *);
void remove_headers(FILE *, FILE *, enum message_type);
int rxmatch(const char *, const char *);
void flushleft(char *, const unsigned);
void chop(char *);
int strileft(const char *, const char *);
int strifind(const char *, const char *);
int strieq(const char *, const char *);
int rxfind(const char *, const char *);
int findline(const char *, const char *);
int print_list(FILE *, const char *);
void cut(const char *, const char *, const char *, const char *);
void mailfile(const char *, const char *);
void runlatentqueue(void);
void queuelatent(const char *, const char *);
int parsetime(const char *, const int);
int run_cmd(const char *, const char *, const char *, FILE *, FILE *);
int append_url(const char *, const char *, const char *);
void encrypt_sub(const char *, const char *);
void updatestats(enum stats_flag);
void mailstats(const char *);
void mailconf(const char *);

#endif /* !FREEDOM_H */
